#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sun Mar 17 17:53:41 2019

@author: gilles
"""

###############
# Exercice 1 #
#############

""" Fonction bonjour(prenom : chaîne; chaîne)
prenom : mot à ajouter dans le message
renvoie la chaîne "bonjour "+prenom"""

def bonjour(prenom):
    return "Bonjour "+prenom

###############
# Exercice 2 #
#############

""" Fonction suiteUn()
n : entier, variant entre 1 et 10, rang du terme dans la suite (u_n) définie par : u_n=4n+5
affiche les 10 premiers termes de la suite (u_n) """
    
def suiteUn():
    for n in range(10):
        print(4*n+5)


""" Fonction suiteUn2(N:entier;)
N : nombre de termes à afficher
n : entier, variant entre 1 et N, rang du terme dans la suite (u_n) définie par : u_n=4n+5
affiche les N premiers termes de la suite (u_n) """

def suiteUn2(N):
    for n in range(N):
        print(4*n+5)

""" Fonction suiteVn()
n : entier, variant entre 1 et 10, rang du terme dans la suite (v_n) définie par : v_{n+1}=4v_n+5
affiche les 10 premiers termes de la suite (v_n) """
    

def suiteVn():
    v=2
    for n in range(10):
        v=4*v+5
        print(v)
        
""" Fonction suiteVn2(N:entier;)
N : nombre de termes à afficher
n : entier, variant entre 1 et N, rang du terme dans la suite (v_n) définie par : v_{n+1}=4v_n+5
affiche les N premiers termes de la suite (v_n) """

def suiteVn2(N):
    v=2
    for n in range(N):
        v=4*v+5
        print(v)
        
################
# Exercice 3  #
##############
    
""" Fonction maximum(a,b : flottants; flottant)
a,b : nombres dont on veut connaître le plus grand
renvoie le plus grand des deux nombres """

def maximum(a,b):
    if a>b:
        return a
    else:
        return b

""" Fonction maximumListe(l : liste ; maxi :  flottant)
l : liste dont on veut connaitre le plus grand élément
n : entier, longueur de la liste
i : entier, index courant dans l
renvoie maxi, le plus grand nombre de l """

def maximumListe(l):
    maxi=l[0]
    n=len(l)
    for i in range(n):
        maxi=maximum(l[i],maxi)         # on utilise la fonction précédente
    return maxi

###############
# Exercice 4 #
##############
    
""" Fonction tripletsPythagoriciens(n : entier; liste : tableau d'entiers)
a,b,c : entiers, pour lesquels on vérifie s'ils peuvent être les côtés d'un triangle rectangle d'hypotènuse c
renvoie liste, la liste des triplets [a,b,c] qui vérifie l'égalité de Pythagore """
    
def tripletsPythagoriciens(n):
    liste=[]
    for c in range(1,n+1):
        for a in range(1,c+1):
            for b in range(1,a+1):
                if a**2+b**2==c**2:
                    liste.append([a,b,c])
    return liste

###############
# Exercice 5 #
#############
    
""" Fonction miroir(mot : chaîne;refl : chaîne)
mot : texte dont on veut le miroir
n : entier, longueur du mot
i : entier, position du caractère courant dans mot
renvoie refl, le miroir du texte message """


def miroir(mot):
    n=len(mot)
    refl=""
    for i in range(n):
        refl=refl+mot[n-i-1]
    return refl

""" Fonction palindrome(mot : chaîne ; booléen)
mot : texte dont on veut savoir si c'est un palindrome ou non
renvoie 'True' si mot est un palindrome, 'False' sinon."""

def palindrome(mot):
    return mot==miroir(mot)